; *** ShowPic ver 1.1 (C) 1997 by Dines Justesen ***
;
; This is a very simpel greyscale test, 4 pictures
; are display right after each other as fast as
; possible (no interrupts or delays).
;
; This program does not use the rutine from the rom to
; display the pictures, because the rutine is not
; very well written.
;
; The pictures are taken from a similar TI85 program,
; but since i no longer have the program  do not know
; who made them.
;
; History:
;  1.0 : First version reeased
;  1.1 : Pictures are now included in the program (the other
;        method used too many of the ti82 vars, and was too
;        complicated).

#INCLUDE "ti82.h"
#INCLUDE "graph.h"

;--------------------------------------------------------------------------
; Definitions
;--------------------------------------------------------------------------

#DEFINE ShowPic(addr) LD HL,addr \ CALL ShowPicture \ CALL GET_KEY \ CP $37 \ JR Z,Exit

;--------------------------------------------------------------------------
; Program
;--------------------------------------------------------------------------

.ORG START_ADDR
.DB "ShowPic ver 1.1 by DJ",0
        TEXT_START
        ROM_CALL(CLEARLCD)
Loop:
        ShowPic(Pic1)
        ShowPic(Pic2)
        ShowPic(Pic3)
        ShowPic(Pic4)
        JR Loop
Exit:
        TEXT_END
        RET

ShowPicture:
        DI
        LD A,7
        CALL $7F3
        OUT ($10),A
        LD A,$80
LineLoop:
        LD D,A          ; Save currect coloum
        CALL $7F3
        OUT ($10),A
        LD A,$20        ; Goto top
        CALL $7F3
        OUT ($10),A
        LD BC,$0C11     ; 40 bytes to port 10
WriteLoop:              ; Write them
        NEG
        NEG
        NEG
        NEG
        OUTI
        JR NZ,WriteLoop
        LD A,D
        INC A
        CP $C0
        JR NZ,LineLoop
        EI
        RET

Pic1:
#INCLUDE "PIC1.INC"
Pic2:
#INCLUDE "PIC2.INC"
Pic3:
#INCLUDE "PIC3.INC"
Pic4:
#INCLUDE "PIC4.INC"
.END
